--- old/usr/src/cmd/sgs/libld/common/args.c	Sun Jul 30 04:56:38 2017
+++ new/usr/src/cmd/sgs/libld/common/args.c	Sun Jul 30 04:56:38 2017
@@ -27,6 +27,7 @@
  */
 /*
  * Copyright (c) 2012, Joyent, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 /*
@@ -1237,6 +1238,14 @@
 			DBG_CALL(Dbg_args_option(ofl->ofl_lml, ndx, c, optarg));
 
 			/*
+			 * Skip comma that might be present between -z and its
+			 * argument (e.g. if -Wl,-z,assert-deflib was passed).
+			 */
+			if (strncmp(optarg, MSG_ORIG(MSG_STR_COMMA),
+			     MSG_STR_COMMA_SIZE) == 0)
+				optarg++;
+
+			/*
 			 * For specific help, print our usage message and exit
 			 * immediately to ensure a 0 return code.
 			 */
--- old/usr/src/cmd/sgs/libld/common/libld.msg	Sun Jul 30 04:56:38 2017
+++ new/usr/src/cmd/sgs/libld/common/libld.msg	Sun Jul 30 04:56:38 2017
@@ -25,6 +25,7 @@
 
 #
 # Copyright (c) 2012, Joyent, Inc.  All rights reserved.
+# Copyright 2017 RackTop Systems.
 #
 
 @ _START_
@@ -730,6 +731,7 @@
 @ MSG_QSTR_STAR		"'*'"
 @ MSG_STR_DOT		"."
 @ MSG_STR_SLASH		"/"
+@ MSG_STR_COMMA		","
 @ MSG_STR_DYNAMIC	"(.dynamic)"
 @ MSG_STR_ORIGIN	"$ORIGIN"
 @ MSG_STR_MACHINE	"$MACHINE"
--- old/usr/src/cmd/sgs/packages/common/SUNWonld-README	Sun Jul 30 04:56:38 2017
+++ new/usr/src/cmd/sgs/packages/common/SUNWonld-README	Sun Jul 30 04:56:38 2017
@@ -1660,3 +1660,4 @@
 6252	ld should merge function/data-sections in the same manner as GNU ld
 7323	ld(1) -zignore can erroneously discard init and fini arrays as unreferenced
 7594	ld -zaslr should accept Solaris-compatible values
+8616	ld has trouble parsing -z options specified with -Wl
